/* nome di questo file: opLVoid.c, contiene 
*le operazioni di ricerca, rimozione e aggiunta di un elemento
in una lista concatenata*/


#include "ProtOpList.h"

 int  keyComp( void * x, void* y);
/* postc: restituisce 0 se  x=y*/

CollPtr creaNodo(void* el);


CollPtr creaNodo(void* el)
/*Crea un nodo il cui campo informazione contiene el
*postc:restituisce un puntatore a un nodo il cui campo informazione contiene el*/

{ CollPtr lPtr = calloc(1,sizeof(Nodo));
 if (!lPtr)  return 0; 
 lPtr ->elem = calloc(1,sizeof(void*));
  if (!lPtr -> elem ) return 0;
   lPtr ->elem = el;
   return lPtr;}

int addElem(CollPtr *L, void* el)
/* Aggiunge l'elemento el in testa alla lista L
  *postc: restituisce 1 se  il nuovo elemento  stato inserito 
 * in testa, 0 se non c' memoria sufficiente per un nuovo nodo. 
 */

{ CollPtr lPtr;
 if (lPtr = creaNodo(el)) 
 {	if (*L != NULL) lPtr -> nextPtr = *L; 
   (*L) = lPtr;
 return 1;} 
 else return 0;
  } 
  

int cerca(CollPtr L, void* el)
/* verifica  se l'elemento el occorre (almeno una volta)
 * nella lista L
 *postc: se la lista e' non vuota  restituisce il numero delle 
 *occorrenze dell'elemento ,  -1 altrimenti.
 */
 {
if (!L) return -1;
 if (keyComp( L ->elem,el) == 0) 
{if (L-> nextPtr) return 1 + cerca(L-> nextPtr,el);else return 1;}
else 
if (L-> nextPtr) return cerca(L -> nextPtr, el); else return 0;
}						

int remEl(CollPtr *L, void* el)
/*rimuove tutte le occorrenze di el nella lista nPtr
* prec: L!=NULL;
 *postc: restituisce il numero delle occorrenze rimosse
 *se la rimozione  avvenuta, 0 altrimenti*/

{CollPtr tPtr;
if (keyComp((*L) ->elem, el) == 0)
    {tPtr = *L;
     (*L) = (*L)->nextPtr;
  	free(tPtr); 
  if (*L != NULL) return 1 + remEl(L, el);
	else  return 1;}
 else 
if ((*L)->nextPtr != NULL) return (remEl(&(*L)->nextPtr, el));
 else return 0;}


 		 



