/*esercizio 1 del 4/7/03
*Consideriamo alberi binari di interi senza ripetizioni.
* Si definisca la funzione ricorsiva C
*int path(TreePtr t,int x, int y)
che restituisce 1 se c' un cammino padri-figli,
* nell'albero t, che porta da un nodo il cui  campo intero  x a 
*uno il cui  campo intero  y, 0 altrimenti.*/

int path(treePtr t, int x, int y)
/* prec: (t != NULL)&&(t non contiene ripetizioni)
*postc: restituisce 1 se c' un cammino padri-figli 
*che porta da un nodo di campo elem x a uno di campo elem y, 0 altrimenti. */
{if (cerca(cerca(t,x),y)) return 1; else return 0;}


treePtr cerca(treePtr t, int x)
/* prec: _
*postc: restituisce il puntatore al primo nodo 
*dell'albero di campo elem x se lo trova, NULL altrimenti */
{ treePtr tempPtr;
  if (!t) return NULL;
  if (t->elem == x) return t;
  tempPtr = cerca(t->lPtr,x);
  if (!tempPtr) return cerca(t-> rPtr,x);
  else return tempPtr;
}

/*Esercizio  2. Consideriamo alberi n-ari di interi. 
*Si definisca la funzione ricorsiva C
*NTreePtr camm(NTreePtr t, char* x)
*che restituisce il nodo individuato 
*dal cammino che parte dalla radice e arriva in un nodo, 
*seguendo archi padre-figlio, 
*descritto in x come una stringa sui caratteri 
*'1',,'9'. Se x   la stringa vuota, ma t non  NULL la funzione 
*deve restituire la radice di t, 
*inoltre restituir NULL se il cammino descritto non esiste in t.
*Esempio: il cammino "132" individua il 
* secondo figlio del terzo figlio del primo figlio della radice.*/


ALBERONARIO camm(ALBERONARIO t,char* x)
/* restituisce il nodo individuato 
*dal cammino 
*descritto in x come una stringa sui caratteri '1',,'9' 
*prec: x contiene solo i caratteri '1',,'9', oltre a quello di terminazione stringa
*postc: restituisce il nodo individuato dal cammino 
*descritto in x, se c'e', NULL altrimenti */ 
{int i;
assert(*x == '\0'|| *x >= '1' && *x <='9');  /*controllo precondizione*/
if (!t) return NULL;
if (*x == '\0') return t;
t = t-> primofiglio;
for (i=0;i < *x - ASCIUNO && t; i++) /*  ASCIUNO e' il numero d'ordine di 1 nella tab ASCI */
t = t-> fratello;
if (!t) return NULL; 
	else return camm(t,++x);
}

ALBERONARIO camm2(ALBERONARIO t,char* x)
/*Una versione alternativa di camm, in cui si usa atoi */ 
{ALBERONARIO temp;
int i, n = atoi(x); 
if (!t) return NULL;
if (*x == '\0') return t;
n = n/(pow(10,strlen(x)-1)); /*voglio avere la prima cifra di n */
temp = t-> primofiglio;
for (i=0;i < (n - 1) && temp; i++) 
temp = temp-> fratello;
if (!temp) return NULL; 
	else return camm2(temp,++x);

}
